$(function(){
$("#gridContainer").dxDataGrid({
dataSource: orders,
showBorders: true,
columnChooser: {
enabled: true
},
loadPanel: {
enabled: true
},
columns: [{
dataField: "OrderNumber",
caption: "Invoice Number"
}, "OrderDate", "Employee", {
caption: "City",
dataField: "CustomerStoreCity"
}, {
caption: "State",
groupIndex: 0,
dataField: "CustomerStoreState",
}, {
dataField: "SaleAmount",
alignment: "right",
format: "currency"
}],
onToolbarPreparing: function(e) {
var dataGrid = e.component;
e.toolbarOptions.items.unshift({
location: "before",
template: function(){
return $("<div/>")
.addClass("informer")
.append(
$("<h2 />")
.addClass("count")
.text(getGroupCount("CustomerStoreState")),
$("<span />")
.addClass("name")
.text("Total Count")
);
}
}, {
location: "before",
widget: "dxSelectBox",
options: {
width: 200,
items: [{
value: "CustomerStoreState",
text: "Grouping by State"
}, {
value: "Employee",
text: "Grouping by Employee"
}],
displayExpr: "text",
valueExpr: "value",
value: "CustomerStoreState",
onValueChanged: function(e) {
dataGrid.clearGrouping();
dataGrid.columnOption(e.value, "groupIndex", 0);
$(".informer .count").text(getGroupCount(e.value));
}
}
}, {
location: "before",
widget: "dxButton",
options: {
text: "Collapse All",
width: 136,
onClick: function(e) {
var expanding = e.component.option("text") === "Expand All";
dataGrid.option("grouping.autoExpandAll", expanding);
e.component.option("text", expanding ? "Collapse All" : "Expand All");
}
}
}, {
location: "after",
widget: "dxButton",
options: {
icon: "refresh",
onClick: function() {
dataGrid.refresh();
}
}
});
}
});
function getGroupCount(groupField) {
return DevExpress.data.query(orders)
.groupBy(groupField)
.toArray().length;
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.4/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gridContainer"></div>
</div>
</body>
</html>
#gridContainer .dx-datagrid-header-panel {
padding: 0;
background-color: rgba(85, 149, 222, 0.6);
}
#gridContainer .dx-datagrid-header-panel .dx-toolbar {
margin: 0;
padding-right: 20px;
background-color: transparent;
}
#gridContainer .dx-datagrid-header-panel .dx-toolbar-items-container {
height: 70px;
}
#gridContainer .dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:not(:first-child) {
background-color: rgba(103, 171, 255, 0.6);
}
#gridContainer .dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:last-child {
padding-right: 10px;
}
#gridContainer .dx-datagrid-header-panel .dx-selectbox {
margin: 17px 10px;
}
#gridContainer .dx-datagrid-header-panel .dx-button {
margin: 17px 0;
}
#gridContainer .informer {
height: 70px;
width: 130px;
text-align: center;
color: #fff;
}
#gridContainer .count {
padding-top: 15px;
line-height: 27px;
margin: 0;
}
var orders = [{
"ID" : 1,
"OrderNumber" : 35703,
"OrderDate" : new Date(2014, 3, 10),
"SaleAmount" : 11800,
"Terms" : "15 Days",
"TotalAmount" : 12175,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 4,
"OrderNumber" : 35711,
"OrderDate" : new Date(2014, 0, 12),
"SaleAmount" : 16050,
"Terms" : "15 Days",
"TotalAmount" : 16550,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 5,
"OrderNumber" : 35714,
"OrderDate" : new Date(2014, 0, 22),
"SaleAmount" : 14750,
"Terms" : "15 Days",
"TotalAmount" : 15250,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 7,
"OrderNumber" : 35983,
"OrderDate" : new Date(2014, 1, 7),
"SaleAmount" : 3725,
"Terms" : "15 Days",
"TotalAmount" : 3850,
"CustomerStoreState" : "Colorado",
"CustomerStoreCity" : "Denver",
"Employee" : "Todd Hoffman"
}, {
"ID" : 9,
"OrderNumber" : 36987,
"OrderDate" : new Date(2014, 2, 11),
"SaleAmount" : 14200,
"Terms" : "15 Days",
"TotalAmount" : 14800,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 11,
"OrderNumber" : 38466,
"OrderDate" : new Date(2014, 2, 1),
"SaleAmount" : 7800,
"Terms" : "15 Days",
"TotalAmount" : 8200,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 14,
"OrderNumber" : 39420,
"OrderDate" : new Date(2014, 1, 15),
"SaleAmount" : 20500,
"Terms" : "15 Days",
"TotalAmount" : 9100,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 15,
"OrderNumber" : 39874,
"OrderDate" : new Date(2014, 1, 4),
"SaleAmount" : 9050,
"Terms" : "30 Days",
"TotalAmount" : 19100,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 18,
"OrderNumber" : 42847,
"OrderDate" : new Date(2014, 1, 15),
"SaleAmount" : 20400,
"Terms" : "30 Days",
"TotalAmount" : 20800,
"CustomerStoreState" : "Wyoming",
"CustomerStoreCity" : "Casper",
"Employee" : "Todd Hoffman"
}, {
"ID" : 19,
"OrderNumber" : 43982,
"OrderDate" : new Date(2014, 4, 29),
"SaleAmount" : 6050,
"Terms" : "30 Days",
"TotalAmount" : 6250,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 29,
"OrderNumber" : 56272,
"OrderDate" : new Date(2014, 1, 6),
"SaleAmount" : 15850,
"Terms" : "30 Days",
"TotalAmount" : 16350,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 30,
"OrderNumber" : 57429,
"OrderDate" : new Date(2013, 11, 31),
"SaleAmount" : 11050,
"Terms" : "30 Days",
"TotalAmount" : 11400,
"CustomerStoreState" : "Arizona",
"CustomerStoreCity" : "Phoenix",
"Employee" : "Clark Morgan"
}];

import React from 'react';
import DataGrid, { Grouping, Column, ColumnChooser, LoadPanel } from 'devextreme-react/data-grid';
import { Template } from 'devextreme-react/core/template';
import query from 'devextreme/data/query';
import service from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.orders = service.getOrders();
this.state = {
expanded: true,
totalCount: this.getGroupCount('CustomerStoreState')
};
this.onToolbarPreparing = this.onToolbarPreparing.bind(this);
this.toolbarItemRender = this.toolbarItemRender.bind(this);
this.dataGrid = null;
}
getGroupCount(groupField) {
return query(this.orders)
.groupBy(groupField)
.toArray().length;
}
toolbarItemRender() {
return (
<div className="informer">
<h2 className="count">{this.state.totalCount}</h2>
<span className="name">Total Count</span>
</div>
);
}
onToolbarPreparing(e) {
e.toolbarOptions.items.unshift({
location: 'before',
template: 'totalGroupCount'
}, {
location: 'before',
widget: 'dxSelectBox',
options: {
width: 200,
items: [{
value: 'CustomerStoreState',
text: 'Grouping by State'
}, {
value: 'Employee',
text: 'Grouping by Employee'
}],
displayExpr: 'text',
valueExpr: 'value',
value: 'CustomerStoreState',
onValueChanged: this.groupChanged.bind(this)
}
}, {
location: 'before',
widget: 'dxButton',
options: {
width: 136,
text: 'Collapse All',
onClick: this.collapseAllClick.bind(this)
}
}, {
location: 'after',
widget: 'dxButton',
options: {
icon: 'refresh',
onClick: this.refreshDataGrid.bind(this)
}
});
}
groupChanged(e) {
this.dataGrid.instance.clearGrouping();
this.dataGrid.instance.columnOption(e.value, 'groupIndex', 0);
this.setState({
totalCount: this.getGroupCount(e.value)
});
}
collapseAllClick(e) {
let newValue = !this.state.expanded;
e.component.option('text', newValue ? 'Collapse All' : 'Expand All');
this.setState({
expanded: newValue
});
}
refreshDataGrid() {
this.dataGrid.instance.refresh();
}
render() {
return (
<DataGrid id="gridContainer"
ref={(ref) => this.dataGrid = ref}
dataSource={this.orders}
showBorders={true}
onToolbarPreparing={this.onToolbarPreparing}>
<Grouping autoExpandAll={this.state.expanded} />
<ColumnChooser enabled={true} />
<LoadPanel enabled={true} />
<Column dataField="OrderNumber" caption="Invoice Number" />
<Column dataField="OrderDate" />
<Column dataField="Employee" />
<Column dataField="CustomerStoreCity" caption="City" />
<Column dataField="CustomerStoreState" caption="State" groupIndex={0} />
<Column dataField="SaleAmount" alignment="right" format="currency" />
<Template name="totalGroupCount" render={this.toolbarItemRender} />
</DataGrid>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-datagrid-header-panel {
padding: 0;
background-color: rgba(85, 149, 222, 0.6);
}
.dx-datagrid-header-panel .dx-toolbar {
margin: 0;
padding-right: 20px;
background-color: transparent;
}
.dx-datagrid-header-panel .dx-toolbar-items-container {
height: 70px;
}
.dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:not(:first-child) {
background-color: rgba(103, 171, 255, 0.6);
}
.dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:last-child {
padding-right: 10px;
}
.dx-datagrid-header-panel .dx-selectbox {
margin: 17px 10px;
}
.dx-datagrid-header-panel .dx-button {
margin: 17px 0;
}
.informer {
height: 70px;
width: 130px;
text-align: center;
color: #fff;
}
.count {
padding-top: 15px;
line-height: 27px;
margin: 0;
}
let orders = [{
'ID' : 1,
'OrderNumber' : 35703,
'OrderDate' : new Date(2014, 3, 10),
'SaleAmount' : 11800,
'Terms' : '15 Days',
'TotalAmount' : 12175,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 4,
'OrderNumber' : 35711,
'OrderDate' : new Date(2014, 0, 12),
'SaleAmount' : 16050,
'Terms' : '15 Days',
'TotalAmount' : 16550,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Jose',
'Employee' : 'Jim Packard'
}, {
'ID' : 5,
'OrderNumber' : 35714,
'OrderDate' : new Date(2014, 0, 22),
'SaleAmount' : 14750,
'Terms' : '15 Days',
'TotalAmount' : 15250,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 7,
'OrderNumber' : 35983,
'OrderDate' : new Date(2014, 1, 7),
'SaleAmount' : 3725,
'Terms' : '15 Days',
'TotalAmount' : 3850,
'CustomerStoreState' : 'Colorado',
'CustomerStoreCity' : 'Denver',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 9,
'OrderNumber' : 36987,
'OrderDate' : new Date(2014, 2, 11),
'SaleAmount' : 14200,
'Terms' : '15 Days',
'TotalAmount' : 14800,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 11,
'OrderNumber' : 38466,
'OrderDate' : new Date(2014, 2, 1),
'SaleAmount' : 7800,
'Terms' : '15 Days',
'TotalAmount' : 8200,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'Los Angeles',
'Employee' : 'Harv Mudd'
}, {
'ID' : 14,
'OrderNumber' : 39420,
'OrderDate' : new Date(2014, 1, 15),
'SaleAmount' : 20500,
'Terms' : '15 Days',
'TotalAmount' : 9100,
'CustomerStoreState' : 'California',
'CustomerStoreCity' : 'San Jose',
'Employee' : 'Jim Packard'
}, {
'ID' : 15,
'OrderNumber' : 39874,
'OrderDate' : new Date(2014, 1, 4),
'SaleAmount' : 9050,
'Terms' : '30 Days',
'TotalAmount' : 19100,
'CustomerStoreState' : 'Nevada',
'CustomerStoreCity' : 'Las Vegas',
'Employee' : 'Harv Mudd'
}, {
'ID' : 18,
'OrderNumber' : 42847,
'OrderDate' : new Date(2014, 1, 15),
'SaleAmount' : 20400,
'Terms' : '30 Days',
'TotalAmount' : 20800,
'CustomerStoreState' : 'Wyoming',
'CustomerStoreCity' : 'Casper',
'Employee' : 'Todd Hoffman'
}, {
'ID' : 19,
'OrderNumber' : 43982,
'OrderDate' : new Date(2014, 4, 29),
'SaleAmount' : 6050,
'Terms' : '30 Days',
'TotalAmount' : 6250,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 29,
'OrderNumber' : 56272,
'OrderDate' : new Date(2014, 1, 6),
'SaleAmount' : 15850,
'Terms' : '30 Days',
'TotalAmount' : 16350,
'CustomerStoreState' : 'Utah',
'CustomerStoreCity' : 'Salt Lake City',
'Employee' : 'Clark Morgan'
}, {
'ID' : 30,
'OrderNumber' : 57429,
'OrderDate' : new Date(2013, 11, 31),
'SaleAmount' : 11050,
'Terms' : '30 Days',
'TotalAmount' : 11400,
'CustomerStoreState' : 'Arizona',
'CustomerStoreCity' : 'Phoenix',
'Employee' : 'Clark Morgan'
}];
export default {
getOrders() {
return orders;
}
};
System.config({
transpiler: 'plugin-babel',
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16/umd/react.development.js',
'react-dom': 'npm:react-dom@16/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme': 'npm:devextreme@19.2',
'devextreme-react': 'npm:devextreme-react@19.2',
'jszip': 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});

<dx-data-grid id="gridContainer"
[dataSource]="orders"
[showBorders]="true"
(onToolbarPreparing)="onToolbarPreparing($event)">
<dxo-grouping [autoExpandAll]="expanded"></dxo-grouping>
<dxo-column-chooser [enabled]="true"></dxo-column-chooser>
<dxo-load-panel [enabled]="true"></dxo-load-panel>
<dxi-column dataField="OrderNumber" caption="Invoice Number"></dxi-column>
<dxi-column dataField="OrderDate"></dxi-column>
<dxi-column dataField="Employee"></dxi-column>
<dxi-column dataField="CustomerStoreCity" caption="City"></dxi-column>
<dxi-column dataField="CustomerStoreState" caption="State" [groupIndex]="0"></dxi-column>
<dxi-column dataField="SaleAmount" alignment="right" format="currency"></dxi-column>
<div *dxTemplate="let data of 'totalGroupCount'">
<div class="informer">
<h2 class="count">{{totalCount}}</h2>
<span class="name">Total Count</span>
</div>
</div>
</dx-data-grid>
import { NgModule, Component, ViewChild, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxDataGridModule,
DxDataGridComponent,
DxTemplateModule } from 'devextreme-angular';
import { Service, Order } from './app.service';
import query from 'devextreme/data/query';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service]
})
export class AppComponent {
@ViewChild(DxDataGridComponent) dataGrid: DxDataGridComponent;
orders: Order[];
expanded = true;
totalCount: number;
constructor(service: Service) {
this.orders = service.getOrders();
this.totalCount = this.getGroupCount('CustomerStoreState');
}
getGroupCount(groupField) {
return query(this.orders)
.groupBy(groupField)
.toArray().length;
}
onToolbarPreparing(e) {
e.toolbarOptions.items.unshift({
location: 'before',
template: 'totalGroupCount'
}, {
location: 'before',
widget: 'dxSelectBox',
options: {
width: 200,
items: [{
value: 'CustomerStoreState',
text: 'Grouping by State'
}, {
value: 'Employee',
text: 'Grouping by Employee'
}],
displayExpr: 'text',
valueExpr: 'value',
value: 'CustomerStoreState',
onValueChanged: this.groupChanged.bind(this)
}
}, {
location: 'before',
widget: 'dxButton',
options: {
width: 136,
text: 'Collapse All',
onClick: this.collapseAllClick.bind(this)
}
}, {
location: 'after',
widget: 'dxButton',
options: {
icon: 'refresh',
onClick: this.refreshDataGrid.bind(this)
}
});
}
groupChanged(e) {
this.dataGrid.instance.clearGrouping();
this.dataGrid.instance.columnOption(e.value, 'groupIndex', 0);
this.totalCount = this.getGroupCount(e.value);
}
collapseAllClick(e) {
this.expanded = !this.expanded;
e.component.option({
text: this.expanded ? 'Collapse All' : 'Expand All'
});
}
refreshDataGrid() {
this.dataGrid.instance.refresh();
}
}
@NgModule({
imports: [
BrowserModule,
DxDataGridModule,
DxTemplateModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #gridContainer .dx-datagrid-header-panel {
padding: 0;
background-color: rgba(85, 149, 222, 0.6);
}
::ng-deep #gridContainer .dx-datagrid-header-panel .dx-toolbar {
margin: 0;
padding-right: 20px;
background-color: transparent;
}
::ng-deep #gridContainer .dx-datagrid-header-panel .dx-toolbar-items-container {
height: 70px;
}
::ng-deep #gridContainer .dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:not(:first-child) {
background-color: rgba(103, 171, 255, 0.6);
}
::ng-deep #gridContainer .dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:last-child {
padding-right: 10px;
}
::ng-deep #gridContainer .dx-datagrid-header-panel .dx-selectbox {
margin: 17px 10px;
}
::ng-deep #gridContainer .dx-datagrid-header-panel .dx-button {
margin: 17px 0;
}
::ng-deep #gridContainer .informer {
height: 70px;
width: 130px;
text-align: center;
color: #fff;
}
::ng-deep #gridContainer .count {
padding-top: 15px;
line-height: 27px;
margin: 0;
}
import { Injectable } from '@angular/core';
export class Order {
ID: number;
OrderNumber: number;
OrderDate: Date;
SaleAmount: number;
Terms: string;
TotalAmount: number;
CustomerStoreState: string;
CustomerStoreCity: string;
Employee:string;
}
let orders: Order[] = [{
"ID" : 1,
"OrderNumber" : 35703,
"OrderDate" : new Date(2014, 3, 10),
"SaleAmount" : 11800,
"Terms" : "15 Days",
"TotalAmount" : 12175,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 4,
"OrderNumber" : 35711,
"OrderDate" : new Date(2014, 0, 12),
"SaleAmount" : 16050,
"Terms" : "15 Days",
"TotalAmount" : 16550,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 5,
"OrderNumber" : 35714,
"OrderDate" : new Date(2014, 0, 22),
"SaleAmount" : 14750,
"Terms" : "15 Days",
"TotalAmount" : 15250,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 7,
"OrderNumber" : 35983,
"OrderDate" : new Date(2014, 1, 7),
"SaleAmount" : 3725,
"Terms" : "15 Days",
"TotalAmount" : 3850,
"CustomerStoreState" : "Colorado",
"CustomerStoreCity" : "Denver",
"Employee" : "Todd Hoffman"
}, {
"ID" : 9,
"OrderNumber" : 36987,
"OrderDate" : new Date(2014, 2, 11),
"SaleAmount" : 14200,
"Terms" : "15 Days",
"TotalAmount" : 14800,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 11,
"OrderNumber" : 38466,
"OrderDate" : new Date(2014, 2, 1),
"SaleAmount" : 7800,
"Terms" : "15 Days",
"TotalAmount" : 8200,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "Los Angeles",
"Employee" : "Harv Mudd"
}, {
"ID" : 14,
"OrderNumber" : 39420,
"OrderDate" : new Date(2014, 1, 15),
"SaleAmount" : 20500,
"Terms" : "15 Days",
"TotalAmount" : 9100,
"CustomerStoreState" : "California",
"CustomerStoreCity" : "San Jose",
"Employee" : "Jim Packard"
}, {
"ID" : 15,
"OrderNumber" : 39874,
"OrderDate" : new Date(2014, 1, 4),
"SaleAmount" : 9050,
"Terms" : "30 Days",
"TotalAmount" : 19100,
"CustomerStoreState" : "Nevada",
"CustomerStoreCity" : "Las Vegas",
"Employee" : "Harv Mudd"
}, {
"ID" : 18,
"OrderNumber" : 42847,
"OrderDate" : new Date(2014, 1, 15),
"SaleAmount" : 20400,
"Terms" : "30 Days",
"TotalAmount" : 20800,
"CustomerStoreState" : "Wyoming",
"CustomerStoreCity" : "Casper",
"Employee" : "Todd Hoffman"
}, {
"ID" : 19,
"OrderNumber" : 43982,
"OrderDate" : new Date(2014, 4, 29),
"SaleAmount" : 6050,
"Terms" : "30 Days",
"TotalAmount" : 6250,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 29,
"OrderNumber" : 56272,
"OrderDate" : new Date(2014, 1, 6),
"SaleAmount" : 15850,
"Terms" : "30 Days",
"TotalAmount" : 16350,
"CustomerStoreState" : "Utah",
"CustomerStoreCity" : "Salt Lake City",
"Employee" : "Clark Morgan"
}, {
"ID" : 30,
"OrderNumber" : 57429,
"OrderDate" : new Date(2013, 11, 31),
"SaleAmount" : 11050,
"Terms" : "30 Days",
"TotalAmount" : 11400,
"CustomerStoreState" : "Arizona",
"CustomerStoreCity" : "Phoenix",
"Employee" : "Clark Morgan"
}];
@Injectable()
export class Service {
getOrders(): Order[] {
return orders;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://github.com/DevExpress/devextreme-angular/blob/master/README.md
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "commonjs",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@7.0.6/lib/plugin.js',
'typescript': 'npm:typescript@2.2.2/lib/typescript.js',
'@angular/core': 'npm:@angular/core@7.1.3/bundles/core.umd.js',
'@angular/common': 'npm:@angular/common@7.1.3/bundles/common.umd.js',
'@angular/compiler': 'npm:@angular/compiler@7.1.3/bundles/compiler.umd.js',
'@angular/platform-browser': 'npm:@angular/platform-browser@7.1.3/bundles/platform-browser.umd.js',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@7.1.3/bundles/platform-browser-dynamic.umd.js',
'@angular/router': 'npm:@angular/router@7.1.3/bundles/router.umd.js',
'@angular/forms': 'npm:@angular/forms@7.1.3/bundles/forms.umd.js',
'@angular/common/http': 'npm:@angular/common@7.1.3/bundles/common-http.umd.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@6.3.3',
'rxjs/operators': 'npm:rxjs@6.3.3/operators',
'devextreme': 'npm:devextreme@18.2',
'jszip': 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.6/dist/quill.js',
'devextreme-angular': 'npm:devextreme-angular@18.2'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'rxjs': { main: 'index.js', defaultExtension: 'js' },
'rxjs/operators': { main: 'index.js', defaultExtension: 'js' },
'devextreme-angular': {
main: 'index.js',
defaultExtension: 'js'
}
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/18.2.6/css/dx.common.css" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/18.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.6.25/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<DxDataGrid
id="gridContainer"
:ref="gridRefName"
:data-source="orders"
key-expr="ID"
:show-borders="true"
>
<DxGrouping :auto-expand-all="expanded"/>
<DxColumnChooser :enabled="true"/>
<DxLoadPanel :enabled="true"/>
<DxColumn
data-field="OrderNumber"
caption="Invoice Number"
/>
<DxColumn data-field="OrderDate"/>
<DxColumn data-field="Employee"/>
<DxColumn
data-field="CustomerStoreCity"
caption="City"
/>
<DxColumn
:group-index="0"
data-field="CustomerStoreState"
caption="State"
/>
<DxColumn
data-field="SaleAmount"
alignment="right"
format="currency"
/>
<DxToolbar>
<DxItem
location="before"
template="totalCountTemplate"
/>
<DxItem
location="before"
template="groupingTemplate"
/>
<DxItem
location="before"
template="collapseTemplate"
/>
<DxItem
location="after"
template="refreshTemplate"
/>
<DxItem
name="columnChooserButton"
/>
</DxToolbar>
<template #totalCountTemplate>
<div class="informer">
<h2 class="count">{{ totalCount }}</h2>
<span class="name">Total Count</span>
</div>
</template>
<template #groupingTemplate>
<DxSelectBox
width="225"
:items="groupingValues"
display-expr="text"
value-expr="value"
value="CustomerStoreState"
@value-changed="groupChanged"
/>
</template>
<template #collapseTemplate>
<DxButton
:text="expanded ? 'Collapse All' : 'Expand All'"
width="136"
@click="collapseAllClick"
/>
</template>
<template #refreshTemplate>
<DxButton
icon="refresh"
@click="refreshDataGrid"
/>
</template>
</DxDataGrid>
</template>
<script>
import {
DxDataGrid,
DxColumn,
DxGrouping,
DxColumnChooser,
DxLoadPanel,
DxToolbar,
DxItem,
} from 'devextreme-vue/data-grid';
import { DxSelectBox } from 'devextreme-vue/select-box';
import { DxButton } from 'devextreme-vue/button';
import query from 'devextreme/data/query';
import service from './data.js';
export default {
components: {
DxDataGrid,
DxColumn,
DxGrouping,
DxColumnChooser,
DxLoadPanel,
DxToolbar,
DxItem,
DxSelectBox,
DxButton,
},
data() {
return {
orders: service.getOrders(),
gridRefName: 'dataGrid',
expanded: true,
totalCount: 0,
groupingValues: [{
value: 'CustomerStoreState',
text: 'Grouping by State',
}, {
value: 'Employee',
text: 'Grouping by Employee',
}],
};
},
created() {
this.totalCount = this.getGroupCount('CustomerStoreState');
},
methods: {
getGroupCount(groupField) {
return query(this.orders)
.groupBy(groupField)
.toArray().length;
},
groupChanged(e) {
this.$refs[this.gridRefName].instance.clearGrouping();
this.$refs[this.gridRefName].instance.columnOption(e.value, 'groupIndex', 0);
this.totalCount = this.getGroupCount(e.value);
},
collapseAllClick() {
this.expanded = !this.expanded;
},
refreshDataGrid() {
this.$refs[this.gridRefName].instance.refresh();
},
},
};
</script>
<style scoped>
.dx-datagrid-header-panel {
padding: 0;
background-color: rgba(85, 149, 222, 0.6);
}
.dx-datagrid-header-panel .dx-toolbar {
margin: 0;
padding-right: 20px;
background-color: transparent;
}
.dx-datagrid-header-panel .dx-toolbar-items-container {
height: 70px;
}
.dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:not(:first-child) {
background-color: rgba(103, 171, 255, 0.6);
}
.dx-datagrid-header-panel .dx-toolbar-before .dx-toolbar-item:last-child {
padding-right: 10px;
}
.dx-datagrid-header-panel .dx-selectbox {
margin: auto 10px;
}
.dx-datagrid-header-panel .dx-button {
margin: auto 0;
}
.informer {
height: 70px;
width: 130px;
text-align: center;
color: #fff;
}
.count {
padding-top: 15px;
line-height: 27px;
font-size: 28px;
margin: 0;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app" />
</div>
</body>
</html>
const orders = [{
ID: 1,
OrderNumber: 35703,
OrderDate: new Date(2014, 3, 10),
SaleAmount: 11800,
Terms: '15 Days',
TotalAmount: 12175,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 4,
OrderNumber: 35711,
OrderDate: new Date(2014, 0, 12),
SaleAmount: 16050,
Terms: '15 Days',
TotalAmount: 16550,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 5,
OrderNumber: 35714,
OrderDate: new Date(2014, 0, 22),
SaleAmount: 14750,
Terms: '15 Days',
TotalAmount: 15250,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 7,
OrderNumber: 35983,
OrderDate: new Date(2014, 1, 7),
SaleAmount: 3725,
Terms: '15 Days',
TotalAmount: 3850,
CustomerStoreState: 'Colorado',
CustomerStoreCity: 'Denver',
Employee: 'Todd Hoffman',
}, {
ID: 9,
OrderNumber: 36987,
OrderDate: new Date(2014, 2, 11),
SaleAmount: 14200,
Terms: '15 Days',
TotalAmount: 14800,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 11,
OrderNumber: 38466,
OrderDate: new Date(2014, 2, 1),
SaleAmount: 7800,
Terms: '15 Days',
TotalAmount: 8200,
CustomerStoreState: 'California',
CustomerStoreCity: 'Los Angeles',
Employee: 'Harv Mudd',
}, {
ID: 14,
OrderNumber: 39420,
OrderDate: new Date(2014, 1, 15),
SaleAmount: 20500,
Terms: '15 Days',
TotalAmount: 9100,
CustomerStoreState: 'California',
CustomerStoreCity: 'San Jose',
Employee: 'Jim Packard',
}, {
ID: 15,
OrderNumber: 39874,
OrderDate: new Date(2014, 1, 4),
SaleAmount: 9050,
Terms: '30 Days',
TotalAmount: 19100,
CustomerStoreState: 'Nevada',
CustomerStoreCity: 'Las Vegas',
Employee: 'Harv Mudd',
}, {
ID: 18,
OrderNumber: 42847,
OrderDate: new Date(2014, 1, 15),
SaleAmount: 20400,
Terms: '30 Days',
TotalAmount: 20800,
CustomerStoreState: 'Wyoming',
CustomerStoreCity: 'Casper',
Employee: 'Todd Hoffman',
}, {
ID: 19,
OrderNumber: 43982,
OrderDate: new Date(2014, 4, 29),
SaleAmount: 6050,
Terms: '30 Days',
TotalAmount: 6250,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 29,
OrderNumber: 56272,
OrderDate: new Date(2014, 1, 6),
SaleAmount: 15850,
Terms: '30 Days',
TotalAmount: 16350,
CustomerStoreState: 'Utah',
CustomerStoreCity: 'Salt Lake City',
Employee: 'Clark Morgan',
}, {
ID: 30,
OrderNumber: 57429,
OrderDate: new Date(2013, 11, 31),
SaleAmount: 11050,
Terms: '30 Days',
TotalAmount: 11400,
CustomerStoreState: 'Arizona',
CustomerStoreCity: 'Phoenix',
Employee: 'Clark Morgan',
}];
export default {
getOrders() {
return orders;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);